// TableDisplay.java
//
// Contains a class to display summary stats on the exam
//
//
// 31may99 Created
/////////////////////////////////////

import javax.swing.JTable;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.table.AbstractTableModel;
import javax.swing.JFrame;
import javax.swing.JTextArea;
import javax.swing.JPanel;
import javax.swing.JSplitPane;
import javax.swing.SwingUtilities;
import javax.swing.JScrollPane;
import java.awt.*;
import java.awt.event.*;

public final class TableDisplay extends JDialog{
    
    
    final int X_SIZE = 350;
    final int Y_SIZE = 150;
    
    
    
    public TableDisplay(Frame frame, String frameName, String [] colNames, Object [][] tableData, String statText){
        super(frame, frameName, true);

    
        // Set up content pane of the topLevelFrame
        JPanel contentPane = new JPanel(new BorderLayout());
        this.getContentPane().add(contentPane);
       
        // Set up the summary pane
        JSplitPane sp = new JSplitPane(JSplitPane.VERTICAL_SPLIT);
        sp.setContinuousLayout(false);
        sp.setDividerSize(5);
        
        // set up Summary panel
        DisplayTableModel tblModel = new DisplayTableModel(colNames, tableData);
        JTable table = new JTable(tblModel);
        table.setPreferredScrollableViewportSize(new Dimension(X_SIZE, Y_SIZE));

        //Create the scroll pane for summary table
        JScrollPane scrollPane = new JScrollPane(table);

        
        Dimension minimumSize = new Dimension(X_SIZE, Y_SIZE);
        scrollPane.setMinimumSize(minimumSize);
        scrollPane.setPreferredSize(minimumSize);
        sp.setTopComponent(scrollPane);
        
        
        // set up a text area for the summary data
        JTextArea text = new JTextArea(12, 10);
        text.append(statText);
        text.setEditable(false);
        text.setLineWrap(true);
        text.setWrapStyleWord(true);
        text.setBackground(Color.lightGray);
        text.setOpaque(true);
        JScrollPane tsp = new JScrollPane(text);
        sp.setBottomComponent(tsp);


        // add splitpane to container component
        contentPane.add(sp, BorderLayout.CENTER);

  
        getContentPane().add(contentPane, BorderLayout.CENTER);
        this.pack();
        this.setVisible(true);
        this.setResizable(true);
        this.setDefaultCloseOperation(JFrame.DISPOSE_ON_CLOSE);

    }
                

    class DisplayTableModel extends AbstractTableModel {
        String[] columnNames;
        
        Object[][] data;
        

        public DisplayTableModel(String [] colHeadings, Object [][] tableData){
            columnNames = colHeadings;
            data = tableData;
        }
        

        public int getColumnCount() {
            return columnNames.length;
        }
        
        public int getRowCount() {
            return data.length;
        }

        public String getColumnName(int col) {
            return columnNames[col];
        }

        public Object getValueAt(int row, int col) {
            return data[row][col];
        }

        public Class getColumnClass(int x) {
            return getValueAt(0, x).getClass();
        }

   }

}