import javax.swing.*;
import java.awt.*;
import javax.swing.event.*;

/**
 * A wrapper around <code>JTextArea</code> that makes it scrollable
 * and a bit prettier.
 *
 * @author	JPL
 */
public class TextScrollPane extends JPanel
{
	private JTextArea textArea;
	private JScrollPane scrollPane;

	public TextScrollPane (String text, int rows, int cols)
	{
		setLayout (new GridLayout (1, 1));
		textArea = new JTextArea (rows, cols);
		textArea.setEditable (false);
		textArea.setLineWrap (true);
		textArea.setWrapStyleWord (true);
		textArea.setText (text);
		textArea.setCaretPosition (0);
		
		scrollPane = new JScrollPane (textArea);
		scrollPane.setBackground (textArea.getBackground());
		scrollPane.setViewportBorder (
			BorderFactory.createEmptyBorder (2, 2, 2, 2) );

		add (scrollPane);
	}

	public String getToolTipText ()
	{
		return textArea.getToolTipText();
	}

	public void setText (String text)
	{
		textArea.setText (text);
		textArea.setCaretPosition (0);
	}

	public void setToolTipText (String toolTip)
	{
		textArea.setToolTipText (toolTip);
	}
}