
import java.util.*;
import java.io.*;
import java.lang.*;

// this is a maintenance class, used for converting the question text file
// to a file containing a serialised vector of question objects.
// this serialised file is then used by Jxam at run-time.


public class dbconvert{

    private final static String qToken = "##------------------------------question------------------------------##";
    private final static String ansToken = "##ans";
    private final static String correctToken = "##correct##";
    private final static String multiToken = "##multipleSelection##";
    private final static String explanationToken = "##explanation##";
    private final static String NL = "\n\r";



    public dbconvert(){
        }


    public static void main(String[] args){



        String inLine = " ";

        boolean doLoop = true;
        File inFile = new File("/home/eddie/Software/Jxam2.0/jxamquestions.txt");
        Vector questionsDB = new Vector();


        RandomAccessFile rafIn;

        try{
            rafIn = new RandomAccessFile(inFile, "r");
            String questionText = "";
            String answerText = "";
            Answer answer = null;
            String expl = "";
            long fileLoc = 0;



            while (doLoop)
            {

                Question question = new Question();

                //---------------------------
                // get question text token
                //---------------------------

                while (inLine.indexOf(qToken) < 0)
                {
                    inLine=rafIn.readLine();
                }
                // read in next line
                inLine=rafIn.readLine();

                // read in all lines up to the 1st answer token, and set
                // as question text.
                while (inLine.indexOf(ansToken) < 0)
                {
                    questionText += inLine + NL;
                    fileLoc = rafIn.getFilePointer();
                    inLine=rafIn.readLine();
                }

                // we're reached the answer token. Set the question text.
                //System.out.println("Question = " +questionText);
                question.setQuestionText(questionText);
                questionText = "";


                //-----------------------------
                // get the various answers
                //-----------------------------
                Vector ans =new Vector();

                rafIn.seek(fileLoc);

                int i = 0;

                do{
                    answerText = "";
                    inLine = "";

                    while (inLine.indexOf(ansToken) < 0)
                    {
                        inLine=rafIn.readLine();
                    }

                    // skip token
                    inLine = rafIn.readLine();

                    // get answer text
                    while ( (inLine.indexOf(ansToken) < 0)
                          && (inLine.indexOf(correctToken) < 0) )
                    {
                        answerText += inLine + NL;
                        fileLoc = rafIn.getFilePointer();
                        inLine=rafIn.readLine();
                    }

                    rafIn.seek(fileLoc);



                    // we've hit the next answer token. Set up current text as
                    // possible answer, but only if it's not a sequence of
                    // white spaces...
                    String temp = answerText.trim();
                    if (temp.length() != 0)
                    {
                        answer = new Answer();
                        answer.setPossibleAnswerText(answerText);

                        //System.out.println("Answer = " + answerText);

                        ans.addElement(answer);
                    }

                    i++;

                }while (i < Question.MAX_ANSWERS_PER_QUESTION);

                inLine = "";
                rafIn.seek(fileLoc);

                //------------------------
                // get the correct answers
                //------------------------
                // read in all lines up to the correct token.
                while (inLine.indexOf(correctToken) < 0)
                    {
                        inLine=rafIn.readLine();
                    }

                // get the line containing the correct answers
                inLine = rafIn.readLine();

                StringTokenizer st = new StringTokenizer(inLine, ",");
                String stNum;
                while(st.hasMoreTokens()){
                    stNum = st.nextToken();
                    stNum.trim();
                    Integer x = new Integer(stNum);
                    int num = x.intValue();

                    // list is 1-based, so deduct 1...
                    num -= 1;

                    Answer tempAns = (Answer)ans.elementAt(num);
                    tempAns.setCorrect(true);
                    }

                // add all answers to the question
                for (int j = 0; j < ans.size(); j++)
                {
                    question.addPossibleAnswer((Answer)ans.elementAt(j));
                }


                //----------------------
                // Get the question type
                //----------------------
                // read in all lines up to the multiselect token.
                while (inLine.indexOf(multiToken) < 0)
                    {
                        inLine=rafIn.readLine();
                    }

                inLine = rafIn.readLine(); // should be true or false
                Boolean tb = new Boolean(inLine);
                question.setMulSel(tb.booleanValue());


                //------------------------
                // get the explanation
                //------------------------
                // read in all lines up to the explanation token.
                while (inLine.indexOf(explanationToken) < 0)
                    {
                        inLine=rafIn.readLine();
                    }

                // build up the entire explanation by reading until either
                // no more questions or the start of another question

                // skip over token
                inLine=rafIn.readLine();


                while ( (inLine!=null) && (inLine.indexOf(qToken) < 0) )
                {
                    expl += inLine + NL;
                    inLine=rafIn.readLine();
                }



                // add explanation to question
                question.setExplanation(expl);
                expl = "";

                //System.out.println(question);

                questionsDB.addElement(question);


            }
        }
        catch (Exception e){
            doLoop = false;
            //e.printStackTrace();
        }


        //System.out.println(questionsDB);
        System.out.println("NUMBER OF QUESTIONS..." + questionsDB.size());



        // write out
        File outFile = new File("/home/eddie/Software/Jxam2.0/questions.db");

        if (outFile.exists())
            outFile.delete();

        try{

            outFile.createNewFile();

            FileOutputStream ostream = new FileOutputStream(outFile);
            ObjectOutputStream p = new ObjectOutputStream(ostream);


            p.writeObject(questionsDB);

            p.flush();
            ostream.close();
        }catch(Exception e){}

    }

}




